Page MenuHomePhabricator

Preprocessor: Suppress -Wnonportable-include-path for header maps
ClosedPublic

Authored by dexonsmith on Apr 19 2017, 7:01 PM.

Details

Summary

If a file search involves a header map, suppress
-Wnonportable-include-path. It's firing lots of false positives for
framework authors internally, and it's not trivial to fix.

Consider a framework called "Foo" with a main (installed) framework header
"Foo/Foo.h". It's atypical for "Foo.h" to actually live inside a
directory called "Foo" in the source repository. Instead, the
build system generates a header map while building the framework.
If Foo.h lives at the top-level of the source repository (common), and
the git repo is called ssh://some.url/foo.git, then the header map will
have something like:

Foo/Foo.h -> /Users/myname/code/foo/Foo.h

where "/Users/myname/code/foo" is the clone of ssh://some.url/foo.git.

After #import <Foo/Foo.h>, the current implementation of
-Wnonportable-include-path will falsely assume that Foo.h was found in a
nonportable way, because of the name of the git clone (.../foo/Foo.h).
However, that directory name was not involved in the header search at
all.

This commit adds an extra parameter to Preprocessor::LookupFile and
HeaderSearch::LookupFile to track if the search used a header map,
making it easy to suppress the warning. Longer term, once we find a way
to avoid the false positive, we should turn the warning back on.

rdar://problem/29849743

Diff Detail

Event Timeline

dexonsmith created this revision.Apr 19 2017, 7:01 PM
eric_niebler added inline comments.Apr 21 2017, 11:24 AM
clang/include/clang/Lex/HeaderSearch.h
401

Why not just add a , bool *IsMapped = nullptr parameter to the existing LookupFile?

Thanks for the review, Eli.

I've changed IsModule to be a required bool* parameter. Setting the default to nullptr looked confusing at call sites.

eric_niebler accepted this revision.Apr 23 2017, 2:21 PM
This revision is now accepted and ready to land.Apr 23 2017, 2:21 PM
dexonsmith closed this revision.Apr 27 2017, 2:55 PM

Fixed in r301592.